/*
 * This source code (including its associated software) is owned by
 * StorageCraft Technology Corporation and is protected by United States and
 * international intellectual property law, including copyright laws, patent
 * laws, and treaty provisions. Use of the source code without modification in
 * connection with StorageCraft products is permitted subject to the End-User
 * License Agreement for StorageCraft Products ("EULA"). A copy of the
 * StorageCraft EULA is available here:
 * https://www.storagecraft.com/legal/license-agreement. Any other use,
 * reproduction, or disclosure without the written permission of StorageCraft
 * Technology Corporation is prohibited.
 *
 * © 2014-2019 StorageCraft Technology Corporation. All rights reserved.
 */

/* Generic read and write operations to a block device. */
#ifndef STCVSM_BLKRW_H
#define STCVSM_BLKRW_H

#include <linux/blkdev.h>

#include "portability.h"

#ifdef WITH_EXT2BITMAP

#define BLK_BUFF_PAGE 0
#define BLK_BUFF_MEM  1
#define BLK_BUFF_BIO  2

int blk_read(struct block_device *bdev, sector_t sector, void *buffer, unsigned int length,
		atomic_t *numbios, int *bio_error, int buff_type);
void blk_read_wait(atomic_t *numbios);

#endif  /* WITH_EXT2BITMAP */

#endif
