/*
 * This source code (including its associated software) is owned by
 * StorageCraft Technology Corporation and is protected by United States and
 * international intellectual property law, including copyright laws, patent
 * laws, and treaty provisions. Use of the source code without modification in
 * connection with StorageCraft products is permitted subject to the End-User
 * License Agreement for StorageCraft Products ("EULA"). A copy of the
 * StorageCraft EULA is available here:
 * https://www.storagecraft.com/legal/license-agreement. Any other use,
 * reproduction, or disclosure without the written permission of StorageCraft
 * Technology Corporation is prohibited.
 *
 * © 2014-2019 StorageCraft Technology Corporation. All rights reserved.
 */

#ifndef STCVSM_EXT2_BITMAP_H
#define STCVSM_EXT2_BITMAP_H

/* Ext2 bitmap extraction
 * Constructed using on-disk format description at:
 *    http://wiki.osdev.org/Ext2
 */
#include <linux/blkdev.h>

struct ext2_super_block;
struct ext2_group_desc;

int ext2_create_bitmap(struct block_device *bdev, unsigned long *bitmap, unsigned long bits_in_map,
		unsigned long _block_size);
void e2sb_debug(struct ext2_super_block *sb);
void e2bgd_debug(unsigned int index, struct ext2_group_desc *bgd);

#endif
