/*
 * This source code (including its associated software) is owned by
 * StorageCraft Technology Corporation and is protected by United States and
 * international intellectual property law, including copyright laws, patent
 * laws, and treaty provisions. Use of the source code without modification in
 * connection with StorageCraft products is permitted subject to the End-User
 * License Agreement for StorageCraft Products ("EULA"). A copy of the
 * StorageCraft EULA is available here:
 * https://www.storagecraft.com/legal/license-agreement. Any other use,
 * reproduction, or disclosure without the written permission of StorageCraft
 * Technology Corporation is prohibited.
 *
 * © 2014-2019 StorageCraft Technology Corporation. All rights reserved.
 */

#ifndef _LOOK_ASIDE_LIST_H
#define _LOOK_ASIDE_LIST_H


/*
 * Look Aside lists interface
 */

struct lookaside_list {
	struct kmem_cache *cache;
	char *name;
	mempool_t *pool;
	size_t size;
};

void lookaside_initialize(
		struct lookaside_list *lookaside,
		void *allocate,
		void *free,
		u32 flags,
		size_t size,
		u32 tag,
		u16 depth);

void *lookaside_allocate(struct lookaside_list *lookaside);
void lookaside_free(struct lookaside_list *lookaside, void *entry);
void lookaside_delete(struct lookaside_list *lookaside);

#endif /* _LOOK_ASIDE_LIST_H */
