/*
 * This source code (including its associated software) is owned by
 * StorageCraft Technology Corporation and is protected by United States and
 * international intellectual property law, including copyright laws, patent
 * laws, and treaty provisions. Use of the source code without modification in
 * connection with StorageCraft products is permitted subject to the End-User
 * License Agreement for StorageCraft Products ("EULA"). A copy of the
 * StorageCraft EULA is available here:
 * https://www.storagecraft.com/legal/license-agreement. Any other use,
 * reproduction, or disclosure without the written permission of StorageCraft
 * Technology Corporation is prohibited.
 *
 * © 2014-2019 StorageCraft Technology Corporation. All rights reserved.
 */

#ifndef STCVSM_SNAPSHOT_SET_H
#define STCVSM_SNAPSHOT_SET_H

#include <linux/types.h>

/** Prepares a snapshot (but does not yet snap it) and adds it to a snapshot set.
 * @param guid  The snapshot set GUID; will be created if it does not already exist
 * @param bdev  The device to snapshot
 * @param cow_dev  The dev_t of the copy-on-write device, or 0 if none
 */
int set_add(u8 guid[16], dev_t bdev_num, dev_t cow_num);
int set_snap(u8 guid[16]);
int set_unsnap(u8 guid[16]);

#endif
