/*
 * This source code (including its associated software) is owned by
 * StorageCraft Technology Corporation and is protected by United States and
 * international intellectual property law, including copyright laws, patent
 * laws, and treaty provisions. Use of the source code without modification in
 * connection with StorageCraft products is permitted subject to the End-User
 * License Agreement for StorageCraft Products ("EULA"). A copy of the
 * StorageCraft EULA is available here:
 * https://www.storagecraft.com/legal/license-agreement. Any other use,
 * reproduction, or disclosure without the written permission of StorageCraft
 * Technology Corporation is prohibited.
 *
 * © 2014-2019 StorageCraft Technology Corporation. All rights reserved.
 */

/* stcvsm_os.h 
 *	layer for shared code, in kernel space some values are define which are not
 *	available in userspace for unittests
 *
 *	using this file allows for the userspace UNITTESTS to define their own os.h file
 *	which then allows define those values
 */

#ifndef STCVSM_OS_H
#define STCVSM_OS_H

#include <linux/types.h>
#include <linux/fs.h>
#include <linux/mempool.h>
#include <linux/slab.h>
#include <linux/bug.h>

/* for use in printk() calls to display module emergency name */
#define	STCVSM_EMERG	"STCVSM "

#endif  /* STCVSM_OS_H */
